<script lang="ts">
import Vue from 'vue';
import SurveyHeader from './survey-header.vue';
import SurveyAccordion from '~/components/developer-survey/2024/survey-accordion.vue';
import SurveyCarousel from '~/components/developer-survey/2024/survey-carousel.vue';
import { IsMobileMixin } from '~/mixins';

export default Vue.extend({
  name: 'SurveyIntro',
  components: {
    SurveyHeader,
    SurveyAccordion,
    SurveyCarousel,
  },
  mixins: [IsMobileMixin],
  props: {
    hero: {
      type: Object,
      required: true,
      default: () => ({}),
    },
    intro: {
      type: Object,
      required: true,
      default: () => ({}),
    },
  },
  data() {
    return {
      currentText: '',
      currentItemIndex: 0,
      prefersReducedMotion: false,
      observer: null,
      isTyping: true,
    };
  },
  mounted() {
    const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
    if (!mediaQuery.matches) {
      this.initIntersectionObserver();
    } else {
      this.prefersReducedMotion = true;
    }
  },
  beforeDestroy() {
    if (this.observer) {
      this.observer.disconnect();
    }
  },
  methods: {
    initIntersectionObserver() {
      const options = {
        root: null,
        rootMargin: '0px',
        threshold: 0.1,
      };

      this.observer = new IntersectionObserver(this.handleIntersect, options);
      const target = this.$refs.listContainer;
      if (target) {
        this.observer.observe(target);
      }
    },
    handleIntersect(entries) {
      entries.forEach((entry) => {
        if (entry.isIntersecting) {
          this.typeWriterEffect();
          if (this.observer) {
            this.observer.disconnect();
          }
        }
      });
    },
    async typeWriterEffect() {
      const items = this.intro.list.items;
      for (let i = 0; i < items.length; i++) {
        this.currentText = '';
        this.currentItemIndex = i;
        const text = items[i].text;
        for (let j = 0; j < text.length; j++) {
          // Adds cursor
          this.currentText = text.slice(0, j + 1) + '|';
          await new Promise((resolve) => setTimeout(resolve, 20));
        }
        this.currentText = text;
        // Wait before starting the next item
        await new Promise((resolve) => setTimeout(resolve, 500));
      }
      // Stop cursor blink after all typing is done
      this.isTyping = false;
    },
  },
});
</script>

<template>
  <div class="intro">
    <section class="hero">
      <SlpContainer>
        <div class="hero__flex">
          <div class="hero__text">
            <h1>
              <span
                class="hero__text--year"
                data-aos="fade-up"
                data-aos-duration="700"
              >
                {{ hero.year }}
              </span>
              <span
                class="hero__text--text"
                data-aos="fade-up"
                data-aos-duration="1000"
              >
                {{ hero.title }}
              </span>
            </h1>
          </div>
          <div class="hero__image--container">
            <img
              preload
              data-aos="fade-left"
              :data-aos-duration="700"
              src="/nuxt-images/developer-survey/2024/2024-survey-hero.png"
              alt=""
            />
          </div>
        </div>
      </SlpContainer>
    </section>
    <section>
      <SlpContainer>
        <SurveyHeader
          :text="intro.survey_header.text"
          :img-variant="1"
          class="slp-mb-32"
        />
        <div class="accordion-grid">
          <SurveyAccordion
            v-if="intro.summary"
            :data="intro.summary"
            background-color="#fff"
            class="summary"
            :open-by-default="isMobile"
          />
          <SurveyAccordion
            v-if="intro.highlights"
            :data="intro.highlights"
            background-color="#F6F3FE"
            class="highlights"
          >
            <SurveyCarousel :data="intro.highlights" />
          </SurveyAccordion>
          <SurveyAccordion
            v-if="intro.list"
            :data="intro.list"
            background-color="#F6F3FE"
            class="list"
          >
            <div ref="listContainer">
              <ol>
                <li v-for="(item, index) in intro.list.items" :key="index">
                  <span v-if="prefersReducedMotion">{{ item.text }}</span>
                  <span v-else-if="index < currentItemIndex">{{
                    item.text
                  }}</span>
                  <span v-else-if="index === currentItemIndex">
                    {{ currentText
                    }}<span v-if="isTyping" class="cursor">|</span>
                  </span>
                </li>
              </ol>
            </div>
          </SurveyAccordion>
        </div>
      </SlpContainer>
    </section>
  </div>
</template>

<style lang="scss" scoped>
.intro {
  padding-bottom: 96px;

  @media (max-width: $breakpoint-md) {
    padding-bottom: 8px;
  }
}
.hero {
  color: #232150;
  padding: 160px 0;
  position: relative;
  background: linear-gradient(179deg, #d7fefe 0.88%, #f2f1f5 99.07%);
  @media (max-width: $breakpoint-md) {
    padding: 64px 0 16px 0;
  }
  &:before {
    @media (min-width: $breakpoint-lg) {
      content: '';
      background: url('/nuxt-images/developer-survey/2024/2024-survey-hero-bg-pills.png');
      background-size: contain;
      background-repeat: no-repeat;
      position: absolute;
      top: 0;
      left: 20%;
      z-index: 3;
      width: 3000px;
      height: 600px;
    }
  }

  &__flex {
    display: flex;
  }

  &__image--container {
    flex: 1 0 30%;
    position: relative;

    @media (max-width: $breakpoint-md) {
      display: none;
    }

    img {
      width: 1000px;
      height: auto;
      z-index: 0;
      position: absolute;
      left: -40%;
      top: -15%;
    }
  }

  &__text {
    flex: 1 0 40%;
    z-index: 5;
    position: relative;
    padding-bottom: 32px;

    &--year {
      display: block;
      font-family: 'GitLab Mono';
      font-weight: $font-weight-bold;
      margin-bottom: 24px;
      @media (max-width: $breakpoint-md) {
        font-size: 24px;
        line-height: 18px;
        margin-bottom: 8px;
      }
    }

    &--text {
      display: block;
      font-weight: $font-weight-bold;
      font-size: 96px;
      line-height: 100px;
      @media (max-width: $breakpoint-md) {
        font-size: 50px;
        line-height: 60px;
      }
    }
  }
}

.accordion-grid {
  display: flex;
  justify-content: space-between;
  gap: 32px;
  flex-wrap: wrap;

  @media (max-width: $breakpoint-md) {
    flex-direction: column;
    gap: 16px;
  }

  .summary {
    flex: 1 0 100%;
  }

  .highlights {
    flex: 1 0 40%;
  }

  .list {
    flex: 1 0 40%;

    ol {
      list-style-type: decimal;
      padding: 20px 0 20px 40px;
    }

    li {
      margin-bottom: 8px;
      font-size: 20px;
      line-height: 32px;
      font-family: 'GitLab Mono';
    }
  }
}
.cursor {
  display: inline-block;
  margin-left: -5px;
  animation: blink 0.7s infinite;
}

@keyframes blink {
  0% {
    opacity: 1;
  }
  50% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}
</style>
